# Installation

## Cloning the repository

The project can be cloned with the command:
`git clone https://gitlab.kit.edu/kit/virtmat-tools/vre-language`.
Alternatively it can be downloaded directly from the [project's  GitLab webpage](https://gitlab.kit.edu/kit/virtmat-tools/vre-language).


## Python version

To ensure support for all required packages and dependencies, Python version 3.9 or higher is required.

## Installation using `pip`

The project can be installed into a desired Python virtual environment using the `pip` package manager.
This is achieved by following these steps:

1. Activate your Python virtual environment accordingly.
2. Make sure you have the latest version of pip for your python installation
    ```
    python -m pip install --upgrade pip
    ```
3. Install packages and dependencies into the environment
    ```
    python -m pip install -e <path_to_folder_containing_setup.cfg>[test]
    ```
The extra `[test]` added to the name of the package installs a set of additional packages for testing the installed package.

## Installation using `conda`

Users employing the **Anaconda** or **Miniconda** Python distributions can use the `conda` package manager to set up the virtual environment and install the package by using the provided `conda-setup.yml`: 
```
conda env create -f conda-setup.yml
```
The extra `[test]` added to the name of the package (see file `conda-setup.yml`) installs a set of additional packages for testing the installed package.

Once the set up is complete, the environment can be activated by entering:

```
conda activate vre-language
```
