""" i/o operations """
from urllib.request import urlopen
# from urllib import request, parse
import yaml


def load_value(url=None, filename=None):
    """load data from file or from URL using the GET method"""
    assert url or filename
    if filename:
        with open(filename, 'r', encoding='utf-8') as inp:
            val = yaml.safe_load(inp)
    elif url:
        with urlopen(url) as inp:
            val = yaml.safe_load(inp)
    return val


def store_value(val, url=None, filename=None):
    """store data to a new file or to an URL using the POST method"""
    assert url or filename
    if filename:
        with open(filename, 'x', encoding='utf-8') as out:
            yaml.safe_dump(val, out)
    elif url:
        raise NotImplementedError
        # data = parse.urlencode(val).encode()
        # req =  request.Request(url, data=data)
        # resp = request.urlopen(req)
