"""define resources available on the computing cluster"""
from virtmat.language.utilities.serializable import ureg

# development queue
res_config = {
    'queue': 'dev_cpuonly',
    'max_tasks_per_node': 76,
    'min_ncores': 1,
    'max_ncores': 912,
    'max_walltime': ureg.Quantity(4, 'hours'),
    'max_memory': ureg.Quantity(3200, 'MB'),
    'min_ntasks': 1,
    'min_nodes': 1,
    'default_nodes': 1,
    'default_ntasks': 1,
    'default_ncores': 1,
    'default_cpus_per_task': 1,
    'default_memory': None,
    'default_mem_per_cpu': ureg.Quantity(1600, 'MB'),
    'default_walltime': ureg.Quantity(10, 'minutes')
}

'''
# production queue
res_config = {
    'queue': 'cpuonly',
    'max_tasks_per_node': 76,
    'min_ncores': 76,
    'max_ncores': 14592,
    'max_walltime': ureg.Quantity(3, 'days'),
    'max_memory': ureg.Quantity(6600, 'MB'),
    'default_ncores': 1,
    'default_memory': None,
    'default_walltime': ureg.Quantity(10, 'minutes')
}
'''


def get_default_qadapter_dict():
    """from the default resources construct a default qadapter dictionary"""
    qadapter = {}
    qadapter['_fw_name'] = 'CommonAdapter'
    qadapter['_fw_q_type'] = 'SLURM'
    qadapter['nodes'] = res_config['default_nodes']
    qadapter['ntasks'] = res_config['default_ntasks']
    qadapter['ntasks_per_node'] = qadapter['ntasks'] // qadapter['nodes']
    qadapter['cpus_per_task'] = res_config['default_cpus_per_task']
    qadapter['walltime'] = int(res_config['default_walltime'].to('minutes').magnitude)
    qadapter['queue'] = res_config['queue']
    qadapter['rocket_launch'] = 'rlaunch singleshot'
    return qadapter
